



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>require.js的初步认识</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">require.js的初步认识</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 10:07:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　我们之前呢写Javascript代码时都会写在一个文件里面，只要加载这一个文件就够了。后来，代码越来越多必须分成多个文件，依次加载。就如下面的代码：</p>
<div>
<pre class="prettyprint linenums">&lt;script src="a.js"&gt;&lt;/script&gt;<br />
　　&lt;script src="b.js"&gt;&lt;/script&gt;<br />
　　&lt;script src="c.js"&gt;&lt;/script&gt;<br />
　　&lt;script src="d.js"&gt;&lt;/script&gt;<br />
　　&lt;script src="e.js"&gt;&lt;/script&gt;<br />
　　&lt;script src="f.js"&gt;&lt;/script&gt;</pre>
</div>
<p>这段代码依次加载多个js文件。</p>
<p>这样写有<strong>两大缺点：</strong></p>
<p>　　<strong>1.加载的时候，浏览器会停止网页渲染，加载文件越多，网页失去响应的时间就会越长；</strong></p>
<p><strong>　　2.由于js文件之间存在依赖关系，因此必须严格保证加载顺序（比如上例的1.js要在2.js的前面），依赖性最大的模块一定要放到最后加载，当依赖关系很复杂的时候，代码的编写和维护都会变得困难。</strong></p>
<p>解决requirejs的两大缺点:</p>
<p>　　（1）实现js文件的异步加载，避免网页失去响应；</p>
<p>　　（2）管理模块之间的依赖性，便于代码的编写和维护。</p>
<p>　　require.js的加载</p>
<div>
<pre class="prettyprint linenums">&lt;script src="js/require.js" defer async="true" &gt;&lt;/script&gt;</pre>
</div>
<p>　　　　使用require.js的第一步，是先去官方网站<a href="http://requirejs.org/docs/download.html" rel="external nofollow noreferrer">下载</a>最新版本。</p>
<p>　　　　下载后，假定把它放在js子目录下面，就可以加载了。</p>
<div>
<pre class="prettyprint linenums">&lt;script src="js/require.js"&gt;&lt;/script&gt;</pre>
</div>
<p>　　　　为了不造成网页失去响应，你可以把它放在网页底部加载，或者这样来写：</p>
<div>
<pre class="prettyprint linenums">&lt;script src="js/require.js" defer async="true" &gt;&lt;/script&gt;</pre>
</div>
<p>　　async属性呢是表明这个文件需要异步加载，避免网页失去响应。IE不支持这个属性，只支持defer，所以把defer也写上。</p>
<p>　　加载require.js以后，下一步就要加载我们自己的代码了。假定我们自己的代码文件是a.js，也放在js目录下面。那么，只需要写成下面这样就行了：</p>
<div>
<pre class="prettyprint linenums">&lt;script src="js/require.js" data-main="js/a"&gt;&lt;/script&gt;</pre>
</div>
<p>　　data-main属性的作用是，指定网页程序的主模块。在上例中，就是js目录下面的a.js，这个文件会第一个被require.js加载。由于require.js默认的文件后缀名是js，所以可以把a.js简写成a。</p>
<p>　　a.js呢我们可以把它称为"主模块"，意思是整个网页的入口代码。</p>
<p>　　这些呢是我对require.js的初步认识。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4951vpeq.html">n皇后2种解题思路与代码-Java与C&plus;&plus;实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlg05x9.html">AC自动机（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde0jx09.html">开发者经验谈：如何一天时间搞定iOS游戏开发？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00enwq.html">Doragon Kuesuto 1&period;15</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v0jlj8.html">abap中的弹出窗体函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde1ze09.html">使用C&num;WebClient类访问（上传&sol;下载&sol;删除&sol;列出文件目录）由IIS搭建的http文件服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1glw39.html">Java EE 7 &sol; JAX-RS 2&period;0&colon; Simple REST API Authentication &amp;amp&semi; Authorization with Custom HTTP Header--reference</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdezxd8.html">iOS之本地推送（前台模式与后台模式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg30xq.html">201521123108 《Java程序设计》第11周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvg2k9.html">项目Alpha冲刺Day1</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxdn59.html">iOS遍历数组的同时删除元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jp76x8.html">SpringBoot 集成 Swageer2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1e1emq.html">潭州课堂25班：Ph201805201 tornado 项目 第十课 深入应用异步和协程（课堂笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1pj349.html">boost&period;asio包装类st&lowbar;asio&lowbar;wrapper开发教程（2013&period;12&period;8更新）（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7mx0q.html">简洁php的MVC框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppe6my9.html">window api 监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kowvprq.html">Sublime的中文GBK显示乱码的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjm6r0q.html">CSC时无法找到C&colon;&bsol;Program Files&bsol;Microsoft SDKs&bsol;Windows&bsol;v6&period;0A&bsol;lib</a>
		</li>
						<li><a href="https://www.batexi.com/a/9535j468.html">Android&mdash;&mdash;Activity中的六个主要函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp16ry9.html">iOS各种问题处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96py3k38.html">蓝桥杯-兰顿蚂蚁-java</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljk5o19.html">The authenticity of host &amp;&num;39&semi;172&period;16&period;33&period;53 &lpar;172&period;16&period;33&period;53&rpar;&amp;&num;39&semi; can&amp;&num;39&semi;t be established的问题&lpar;日志六&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy15rljq.html">Centos7&period;3 安装Mysql5&period;7并修改初始密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy15rkmq.html">java基础----&amp;gt&semi;hashMap的简单分析&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd3x1y9.html">poj1743 Musical Theme 后缀数组的应用&lpar;求最长不重叠重复子串&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk551e8.html">Redis学习-Set</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy150lxq.html">Servlet起步</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pyggv8.html">laravel实现excel表格导出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjreer8.html">MPP 一、Greenplum 集群安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo42mdq.html">【知识整理】惊现RecyclerView内部Bug？？？别急，我们慢慢解决它~</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
